/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core/ES2015/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-react-core/ES2015/Color";
import { ScatterFrame } from "./ScatterFrame";
import { KDTree2D } from "./KDTree2D";
import { Type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, Nullable$1 } from "igniteui-react-core/ES2015/type";
import { Rect } from "igniteui-react-core/ES2015/Rect";
import { IFastItemsSource_$type } from "igniteui-react-core/ES2015/IFastItemsSource";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core/ES2015/List$1";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core/ES2015/PropertyMetadata";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-react-core/ES2015/number";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core/ES2015/array";
import { dateNow } from "igniteui-react-core/ES2015/date";
import { RenderingContext } from "igniteui-react-core/ES2015/RenderingContext";
import { CanvasViewRenderer } from "igniteui-react-core/ES2015/CanvasViewRenderer";
import { Rectangle } from "igniteui-react-core/ES2015/Rectangle";
/**
 * @hidden
 */
export class HighDensityScatterSeries extends Series {
    constructor() {
        super();
        this.l6 = null;
        this.l8 = null;
        this.ne = 0;
        this.ma = false;
        this.mu = 0;
        this.mt = 0;
        this.ms = 0;
        this.mr = 255;
        this.mq = 0;
        this.mp = 0;
        this.mx = 255;
        this.mw = 0;
        this.mv = 0;
        this.ly = null;
        this.l3 = null;
        this.l4 = null;
        this.lz = null;
        this.l1 = null;
        this.mc = false;
        this.nf = 0;
        this.nh = 0;
        this.nb = 0;
        this.na = 0;
        this.progressiveLoadStatusChanged = null;
        this.mh = null;
        this.mn = 0;
        this.mm = 0;
        this.mo = 0;
        this.m0 = 0;
        this.my = 0;
        this.mz = 0;
        this.m1 = 0;
        this.m3 = 0;
        this.m5 = 0;
        this.m4 = 0;
        this.m2 = 0;
        this.mj = 0;
        this.mk = 0;
        this.ml = 0;
        this.mi = 0;
        this.nd = 0;
        this.nc = 0;
        this.lv = null;
        this.ng = 0;
        this.mb = false;
        this._itemIndexes = null;
        this.lw = null;
        this.lt = null;
        this.l5 = null;
        this.ab = HighDensityScatterSeries.$;
        this.c6 = false;
    }
    get_c4() {
        return true;
    }
    get l7() {
        return this.l6;
    }
    set l7(a) {
        if (this.l6 != a) {
            let b = this.l7;
            this.l6 = a;
            this.raisePropertyChanged("XColumn", b, this.l7);
        }
    }
    get l9() {
        return this.l8;
    }
    set l9(a) {
        if (this.l8 != a) {
            let b = this.l9;
            this.l8 = a;
            this.raisePropertyChanged("YColumn", b, this.l9);
        }
    }
    oe() {
        if (this.ly == null) {
            return;
        }
        this.ly.s();
        let a = this.ly;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.n2));
        this.ly = null;
    }
    is(a, b, c, d) {
        super.is(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (this.bs != null) {
                    let e = this.getEffectiveViewport1(this.bi);
                    this.mb = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.oe();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.l7);
                    c.deregisterColumn(this.l9);
                    this.l7 = null;
                    this.l9 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.l7 = this.bw(this.nw);
                    this.l9 = this.bw(this.n0);
                }
                if ((this.l2 != null && !this.l2.ck()) || (this.l0 != null && !this.l0.ck())) {
                    this.i6(false);
                }
                this.id();
                break;
            case HighDensityScatterSeries.$$p[7]:
                let f = this.lz;
                this.lz = this.l0;
                this.oe();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.n5));
                }
                if (this.lz != null) {
                    let g = this.lz;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.n5));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if ((this.l0 != null && !this.l0.ck()) || (d == null && c != null)) {
                    this.i6(false);
                }
                break;
            case HighDensityScatterSeries.$$p[9]:
                let h = this.l1;
                this.l1 = this.l2;
                this.oe();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.n5));
                }
                if (this.l1 != null) {
                    let i = this.l1;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.n5));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if ((this.l2 != null && !this.l2.ck()) || (d == null && c != null)) {
                    this.i6(false);
                }
                break;
            case "MouseOverEnabled":
                this.mc = this.c6;
                this.i6(false);
                break;
            case HighDensityScatterSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.l7);
                    this.l7 = this.bw(this.nw);
                }
                break;
            case "XColumn":
                this.oe();
                if (this.l0 != null && !this.l0.ck()) {
                    this.i6(false);
                }
                this.id();
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.l9);
                    this.l9 = this.bw(this.n0);
                }
                break;
            case "YColumn":
                this.oe();
                if (this.l2 != null && !this.l2.ck()) {
                    this.i6(false);
                }
                this.id();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.oe();
                this.i6(false);
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.i6(false);
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.i6(false);
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.lx.by(this.ot, this.os)) {
                    return;
                }
                this.mu = this.ot.o;
                this.mt = this.ot.n;
                this.ms = this.ot.m;
                this.mr = this.os.o;
                this.mq = this.os.n;
                this.mp = this.os.m;
                this.mx = this.mr - this.mu;
                this.mw = this.mq - this.mt;
                this.mv = this.mp - this.ms;
                this.i6(false);
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.ne = Math.max(typeGetValue(d) - 1, 0);
                this.ma = this.ne > 0;
                this.i6(false);
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.i6(false);
                this.ic();
                break;
        }
    }
    me(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    md(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    n5(a, b) {
        this.oe();
        this.i6(false);
    }
    dv(a, b, c) {
        let d = super.dv(a, b, c);
        if (this.l2 == null || this.l0 == null || this.l0.bf == null || this.l2.bf == null || this.l9 == null || this.l7 == null || this.l9.count < 1 || this.l7.count < 1 || this.l9.count != this.l7.count || this.l0.jx == this.l0.jw || this.l2.jx == this.l2.jw || this.lr.isEmpty) {
            d = false;
        }
        return d;
    }
    get nl() {
        return this.nf;
    }
    set nl(a) {
        let b = this.nf;
        this.nf = a;
        this.raisePropertyChanged("ProgressiveStatus", b, this.nf);
    }
    i7(a) {
        super.i7(a);
        this.n7(a, this.bi);
    }
    n7(a, b) {
        if (this.cc(b)) {
            return;
        }
        if (this.ly == null && !this.mg) {
            let c = new List$1(KDPointData.$, 2, this.l7.count);
            let d = this.l0;
            let e = this.l2;
            let f = new Rect(0, 0, 0, 1, 1);
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(1, f, g, d.b8);
            let i = new ScalerParams(1, f, g, e.b8);
            let j;
            let k;
            for (let l = 0; l < this.l7.count; l++) {
                j = d.dt(this.l7.item(l), h);
                k = e.dt(this.l9.item(l), i);
                if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k)) {
                    c.add(((() => {
                        let $ret = new KDPointData();
                        $ret.a = j;
                        $ret.b = k;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            }
            if (this.mf) {
                this.na = 1;
                this.nb = truncate(logBase(c.count, 2)) + 3;
                this.nl = truncate(((this.na / this.nb) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.nl));
                }
                this.ly = KDTree2D.b(c.toArray(), 1);
                let m = this.ly;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.n2));
                if (!this.ly.f(this.e1)) {
                    let n = this.ly;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.n2));
                }
                this.ic();
            }
            else {
                let o = dateNow();
                this.ly = new KDTree2D(0, c.toArray(), 1);
                let p = dateNow();
            }
        }
        if (this.mf && !this.mg) {
            this.n8(b);
        }
        else {
            this.n9(b);
        }
    }
    hs(a, b, c, d) {
        super.hs(a, b, c, d);
        this.oe();
        let e = false;
        if (this.l0 != null && !this.l0.ck()) {
            e = true;
        }
        if (this.l2 != null && !this.l2.ck()) {
            e = true;
        }
        if (e) {
            this.i6(false);
        }
        this.id();
    }
    n4(a) {
        let b = a;
        let c = this.nd * this.nc;
        if (this.mc) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (let d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (let e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    }
    n9(a) {
        let b;
        let c;
        let d = null;
        if (a.n) {
            d = this._itemIndexes;
        }
        let e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        let f = a;
        let g = this.getEffectiveViewport1(a);
        this.l3 = new ScalerParams(0, b, c, this.lz.b8, g);
        this.l4 = new ScalerParams(0, b, c, this.l1.b8, g);
        this.n3(a);
        this.n4(a);
        let h = this.nd * this.nc;
        if (this.lw == null || this.lw.length != h) {
            this.lw = new Array(h);
            this.lt = new Array(h);
        }
        let i = this.lw.length;
        let j = this.lw;
        let k = this.lt;
        for (let l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.nh = truncate(Math.round(this.er));
        this.lv = f.bv();
        let m = this.lv.length;
        let n = this.lv;
        for (let o = 0; o < m; o++) {
            n[o] = 0;
        }
        let p = this.m8;
        let q = this.m7;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.mn = Math.min(p, q);
        this.mm = Math.max(p, q);
        if (this.mn < 0) {
            this.mn = 0;
        }
        if (this.mm < 0) {
            this.mm = 0;
        }
        this.mo = this.mm - this.mn;
        if (this.mg) {
            this.n6(a);
        }
        else {
            this.og(a);
        }
        f.b6();
        if (a.n) {
            this._itemIndexes = d;
            this.lx.b7();
        }
    }
    n8(a) {
        if (this.ly == null) {
            return;
        }
        this.n9(a);
    }
    n2(a, b) {
        this.lx.b5(() => {
            if (this.na < this.nb - 1) {
                this.na++;
            }
            this.nl = truncate(((this.na / this.nb) * 100));
            if (this.progressiveLoadStatusChanged != null) {
                this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.nl));
            }
            this.n8(this.bi);
            this.ic();
            if (this.ly != null) {
                if (!this.ly.f(this.e1)) {
                    let c = this.ly;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(this, this.n2));
                    this.nl = 100;
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.nl));
                    }
                }
            }
        });
    }
    n6(a) {
        let b = arrayShallowClone(this.l7.asArray());
        this.l0.gh(boxArray$1(b), 0, b.length, this.l3);
        let c = arrayShallowClone(this.l9.asArray());
        this.ng = 0;
        let d = this.ne;
        let e = this.ma;
        let f = this.lw.length;
        this.l2.gh(boxArray$1(c), 0, c.length, this.l4);
        let g = 255 << 24 | truncate(this.mu) << 16 | truncate(this.mt) << 8 | truncate(this.ms);
        for (let h = 0; h < b.length; h++) {
            let i = truncate(b[h]);
            let j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.nd || j < 0 || j >= this.nc) {
                continue;
            }
            if (e) {
                let k = i - d;
                let l = i + d;
                l = l > (this.nd - 1) ? (this.nd - 1) : l;
                k = k < 0 ? 0 : k;
                let m = j + d;
                let n = j - d;
                for (let o = k; o <= l; o++) {
                    for (let p = n; p <= m; p++) {
                        let q = (p * this.nd) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.lw[q] = this.lw[q] + 1;
                        this.lt[q] = 1;
                        this.ng++;
                        if (this.mc) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                let r = (j * this.nd) + i;
                this.lw[r] = this.lw[r] + 1;
                this.lt[r] = 1;
                this.ng++;
                if (this.mc) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.oa();
    }
    og(a) {
        let b;
        let c;
        let d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.ly == null) {
            return;
        }
        if (this.mh == null) {
            this.mh = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.mh.clear();
        }
        let e = c.left;
        let f = c.right;
        let g = c.top;
        let h = c.bottom;
        this.m4 = c.top;
        this.m2 = c.height;
        this.m3 = c.left;
        this.m5 = c.width;
        this.m0 = b.top;
        this.my = b.height;
        this.mz = b.left;
        this.m1 = b.width;
        let i = this.getEffectiveViewport1(a);
        this.mj = (i.left - this.mz) / this.m1;
        this.mk = (i.top - this.m0) / this.my;
        let j = (i.right - this.mz) / this.m1;
        this.ml = j - this.mj;
        let k = (i.bottom - this.m0) / this.my;
        this.mi = k - this.mk;
        if (this.mb) {
            e = (e - this.mj) / this.ml;
            f = (f - this.mj) / this.ml;
            g = (g - this.mk) / this.mi;
            h = (h - this.mk) / this.mi;
        }
        let l = this.er / b.width * c.width;
        let m = this.er / b.height * c.height;
        let n = Math.min(l, m);
        let o = ((() => {
            let $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.ly.t(this.mh, o, 0, 1, 0, 1);
        let p;
        this.ng = 0;
        for (let q = 0; q < this.mh.count; q++) {
            p = this.mh._inner[q];
            this.ob(p);
        }
        this.oa();
    }
    ob(a) {
        if (a.g) {
            return;
        }
        let b = a.e != null && a.e.a;
        let c = a.a == null ? 0 : a.a.length;
        let d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.od(a.b, d, b, a.e);
        if (c > 0 && !b) {
            let e;
            for (let f = 0; f < c; f++) {
                e = a.a[f];
                this.od(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    }
    c8(a) {
        let b = this.bs != null ? this.bs.mq : Rect.empty;
        let c = this.bs != null ? this.bs.m3 : Rect.empty;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = this.ll(this.bi);
        let f = new ScalerParams(0, d, d, this.l0.b8, e);
        let g = new ScalerParams(0, d, d, this.l2.b8, e);
        let h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        let i = this.l0 != null && this.l7 != null && h < this.l7.count ? this.l0.dt(this.l7.item(h), f) : NaN;
        let j = this.l2 != null && this.l9 != null && h < this.l9.count ? this.l2.dt(this.l9.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    }
    od(a, b, c, d) {
        let e = this.nj(b);
        let f = a.c;
        let g = this.ne;
        if (c) {
            let h = d.d;
            let i = d.b;
            let j = d.e;
            let k = d.c;
            if (this.mb) {
                h = this.mj + this.ml * h;
                i = this.mj + this.ml * i;
                j = this.mk + this.mi * j;
                k = this.mk + this.mi * k;
            }
            let l = truncate((this.mz + this.m1 * (h - this.m3) / this.m5));
            let m = truncate((this.mz + this.m1 * (i - this.m3) / this.m5));
            let n = truncate((this.m0 + this.my * (j - this.m4) / this.m2));
            let o = truncate((this.m0 + this.my * (k - this.m4) / this.m2));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.ma) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            let p = ((m - l) + 1) * ((o - n) + 1);
            let q = b / p;
            let r = q;
            for (let s = l; s <= m; s++) {
                for (let t = n; t <= o; t++) {
                    this.oc(f, s, t, q, r);
                }
            }
        }
        else {
            let u = a.a;
            let v = a.b;
            if (this.mb) {
                u = this.mj + this.ml * u;
                v = this.mk + this.mi * v;
            }
            let w = truncate((this.mz + this.m1 * (u - this.m3) / this.m5));
            let x = truncate((this.m0 + this.my * (v - this.m4) / this.m2));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.ma) {
                let y = w - g;
                let z = w + g;
                let aa = x + g;
                let ab = x - g;
                let ac = ((z - y) + 1) * ((aa - ab) + 1);
                let ad = b / ac;
                let ae = ad;
                for (let af = y; af <= z; af++) {
                    for (let ag = ab; ag <= aa; ag++) {
                        this.oc(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.oc(f, w, x, b, 1);
            }
        }
    }
    ni(a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.mu + a * this.mx))) << 16 | truncate(Math.floor(b * (this.mt + a * this.mw))) << 8 | truncate(Math.floor(b * (this.ms + a * this.mv)));
    }
    nj(a) {
        return 255 << 24 | truncate(Math.floor((this.mu + a * this.mx))) << 16 | truncate(Math.floor((this.mt + a * this.mw))) << 8 | truncate(Math.floor((this.ms + a * this.mv)));
    }
    m6(a) {
        return (a >> 24 & 255) / 255;
    }
    oc(a, b, c, d, e) {
        if (b < 0 || b >= this.nd || c < 0 || c >= this.nc) {
            return;
        }
        let f = (c * this.nd) + b;
        this.lw[f] = this.lw[f] + d;
        this.lt[f] = this.lt[f] + e;
        if (this.mc) {
            this._itemIndexes[f] = a + 1;
        }
        this.ng += truncate(d);
    }
    oa() {
        let a = 0;
        let b = 0;
        let c = this.mo;
        let d = this.mn;
        let e = this.mm;
        let f = this.lw.length;
        let g = this.lw;
        let h = this.lt;
        let i = this.lv;
        let j = NaN;
        let k = NaN;
        let l = 0;
        let m = 0;
        for (let n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.ni(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    }
    n3(a) {
        let b = a;
        b.b3();
    }
    bf() {
        return new HighDensityScatterSeriesView(this);
    }
    im(a) {
        super.im(a);
        this.lx = a;
    }
    an(a) {
        if (a != null && a == this.l0 && this.l7 != null) {
            return new AxisRange(this.l7.minimum, this.l7.maximum);
        }
        if (a != null && a == this.l2 && this.l9 != null) {
            return new AxisRange(this.l9.minimum, this.l9.maximum);
        }
        return null;
    }
    jl(a, b) {
        if (this.bs != null) {
            let c = this.getEffectiveViewport1(this.bi);
            this.mb = !c.isEmpty;
        }
        this.i6(false);
    }
    jm(a, b) {
        this.i6(false);
    }
    fm(a) {
        if (!this.mc || this._itemIndexes == null || this.bs == null || this.bz == null || this._itemIndexes.length != (this.nd * this.nc)) {
            return null;
        }
        let b = this.bs.mq;
        let c = (a.x - b.left) / b.width;
        let d = (a.y - b.top) / b.height;
        let e = truncate(Math.round(this.lr.left + (this.lr.width * c)));
        let f = truncate(Math.round(this.lr.top + (this.lr.height * d)));
        let g = this.nm(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        let h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.bz.count) {
            return null;
        }
        return this.bz.item(h);
    }
    nm(a, b) {
        let c = (this.nd * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        let d = 1;
        c = (this.nd * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nd * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    }
    of(a, b, c) {
        this.lv = a;
        this.nd = b;
        this.nc = c;
    }
    get_dp() {
        return true;
    }
    set_dp(a) {
        super.set_dp(a);
    }
    hp(a, b) {
        super.hp(a, b);
        this.lx.b4();
        if (this.bh != null) {
            this.bh.b4();
        }
        this.ic();
    }
    i8(a, b) {
        super.i8(a, b);
        if (!this.dk) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        let c = typeCast(HighDensityScatterSeriesView.$, this.bh);
        let d = new ScatterFrame();
        this.n7(false, c);
        this.dk = false;
    }
    i5(a, b, c, d, e) {
        super.i5(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.l5 == null) {
            this.l5 = new ScatterFrame();
        }
        this.n7(false, f);
    }
    hn() {
        super.hn();
        this.l0 = null;
        this.l2 = null;
    }
}
HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
Type.dep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:os:oh', [Color.$, null], 'HeatMaximum:m7:oi', [1, 50], 'HeatMinimumColor:ot:oj', [Color.$, null], 'HeatMinimum:m8:ok', [1, 0], 'PointExtent:nk:ol', [1, 1], 'ProgressiveLoad:mf:om', [0, true], 'UseBruteForce:mg:on', [0, false], 'XAxis:l0:oo', [NumericXAxis.$, null], 'XMemberPath:nw:op', [2, null], 'YAxis:l2:oq', [NumericYAxis.$, null], 'YMemberPath:n0:or', [2, null]]);
/**
 * @hidden
 */
export class HighDensityScatterSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bw = null;
        this.bu = null;
        this.b2 = 0;
        this.b1 = 0;
        this.bz = null;
        this.b0 = null;
        this.bx = null;
        this.bw = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.er = 4;
            this.bw.ot = Color.u(255, 0, 0, 0);
            this.bw.os = Color.u(255, 255, 0, 0);
        }
    }
    b7() {
        this.bw.of(this.bu, this.b2, this.b1);
    }
    b3() {
        if (this.bz == null) {
            this.bz = this.e.e1.createElement("canvas");
            let a = this.e.e1.get2DCanvasContext(this.bz);
            this.bx = new RenderingContext(new CanvasViewRenderer(), a);
        }
        let b;
        if (this.m) {
            b = this.br;
        }
        else {
            b = this.e.bs.mv();
        }
        let c = truncate(Math.round(b.left));
        let d = truncate(Math.round(b.top));
        let e = truncate(Math.round(b.width));
        let f = truncate(Math.round(b.height));
        let g = this.b2;
        let h = this.b1;
        this.b2 = e;
        this.b1 = f;
        if (g != this.b2 || h != this.b1 || this.bu == null) {
            this.bz.setAttribute("width", e.toString());
            this.bz.setAttribute("height", f.toString());
            this.b0 = this.bx.g().getImageData(0, 0, e, f);
            let imageDataArray_ = this.b0.data;
            this.bu = imageDataArray_;
        }
        this.bw.of(this.bu, this.b2, this.b1);
    }
    bv() {
        return this.bu;
    }
    b6() {
        let a = truncate(Math.round(this.br.left));
        let b = truncate(Math.round(this.br.left));
        let c = truncate(Math.round(this.br.width));
        let d = truncate(Math.round(this.br.height));
        this.bx.g().putImageData(this.b0, 0, 0);
        this.an();
    }
    b5(a) {
        if (this.e.e1 != null) {
            this.e.e1.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            if (!this.bw.c6) {
                return;
            }
            let c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
            return;
        }
        if (this.bz == null) {
            return;
        }
        let d = truncate(Math.round(this.br.left));
        let e = truncate(Math.round(this.br.top));
        let f = truncate(Math.round(this.br.width));
        let g = truncate(Math.round(this.br.height));
        this.h.n(this.bz.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    }
    by(a, b) {
        return Color.e(Nullable$1.toNullable(Color.$, a), Nullable$1.toNullable(Color.$, null)) && Color.e(Nullable$1.toNullable(Color.$, b), Nullable$1.toNullable(Color.$, null));
    }
    b4() {
        if (this.bu != null) {
            for (let a = 0; a < this.bu.length; a++) {
                this.bu[a] = 0;
            }
            this.b6();
        }
    }
    ai(a) {
        super.ai(a);
        if (this.bu == null) {
            this.e.a2.exportSeriesPixelsData(a, null, this.b2, this.b1);
            return;
        }
        let b = new Array(intDivide(this.bu.length, 4));
        let c;
        for (let d = 0; d < intDivide(this.bu.length, 4); d++) {
            c = d * 4;
            b[d] = this.bu[c + 3] << 24 | this.bu[c] << 16 | this.bu[c + 1] << 8 | this.bu[c + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, b, this.b2, this.b1);
    }
}
HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
